package org.example;

// on pourra la modifier par la suite si des éléments ne conviennent pas 
public abstract class Character {
    protected String name;
    protected int maxHP;
    protected int currentHP;
    protected int attackPower;
    protected int defense;
    protected SpecialAbility specialAbility;

    public Character(String name, int maxHP, int attackPower, int defense) {
        this.name = name;
        this.maxHP = maxHP;
        this.currentHP = maxHP;
        this.attackPower = attackPower;
        this.defense = defense;
    }

    public boolean isAlive() {
        return currentHP > 0;
    }

    public void takeDamage(int damage) {
        int actualDamage = Math.max(damage - defense, 0);
        currentHP = Math.max(currentHP - actualDamage, 0);
        System.out.println(name + " subit " + actualDamage + " dégâts. (PV restants : " + currentHP + ")");
    }

    public abstract void attack(Character target);

    public void useSpecialAbility(Character target) {
        if (specialAbility != null) {
            specialAbility.activate(this, target);
        }
    }
}
